﻿Imports System.Collections.ObjectModel
Imports MultiSelectExample.Instrastructure

Public Class MainViewModel
    Inherits ViewModelBase

    Private _resultsSelectionChangedCommand As RelayCommand


    Public Property SelectedSongs As ObservableCollection(Of SongViewModel)


    Public Sub New()
        SelectedSongs = New ObservableCollection(Of SongViewModel)
        AllSongs = New ObservableCollection(Of SongViewModel) From {
            New SongViewModel(New Song("Ievan Pollka", "Die besten Hits", "Dance")),
            New SongViewModel(New Song("Wäre ich ein Säugetier?", "Musik - 7. Klasse", "Sprechgesang")),
            New SongViewModel(New Song("Gayway Girl", "KP", "Pop"))
        }

        CurrentSong = AllSongs.FirstOrDefault()
    End Sub


    Private _AllSongs As ObservableCollection(Of SongViewModel)
    Public Property AllSongs As ObservableCollection(Of SongViewModel)
        Get
            Return _AllSongs
        End Get
        Set(value As ObservableCollection(Of SongViewModel))
            _AllSongs = value
            RaisePropertyChanged()
        End Set
    End Property


    Private _currentSong As SongViewModel
    Public Property CurrentSong() As SongViewModel
        Get
            Return _currentSong
        End Get
        Set(ByVal value As SongViewModel)
            _currentSong = value
            RaisePropertyChanged()
        End Set
    End Property


    Public ReadOnly Property ResultsSelectionChangedCommand() As RelayCommand
        Get
            If _resultsSelectionChangedCommand Is Nothing Then
                _resultsSelectionChangedCommand = New RelayCommand(AddressOf ResultsSelectionChanged)
            End If
            Return _resultsSelectionChangedCommand
        End Get
    End Property

    Public Sub ResultsSelectionChanged(ByVal selectedItems As Object)

        SelectedSongs.Clear()
        For Each item In selectedItems
            SelectedSongs.Add(item)
        Next
        If SelectedSongs.Count > 1 Then
            CurrentSong = New MultipleSongViewModel()
            AddHandler DirectCast(CurrentSong, MultipleSongViewModel).Saved, AddressOf MultipleSongs_Saved
        End If
    End Sub

    Private Sub MultipleSongs_Saved(sender As SongViewModel)
        For Each s In SelectedSongs
            If Not CurrentSong.Title = MultipleSongViewModel.MultipleIndicator Then
                SelectedSongs.ToList().ForEach(Sub(x) x.Title = s.Title)
            End If
            If Not CurrentSong.Album = MultipleSongViewModel.MultipleIndicator Then
                SelectedSongs.ToList().ForEach(Sub(x) x.Album = s.Album)
            End If
            If Not CurrentSong.Genre = MultipleSongViewModel.MultipleIndicator Then
                SelectedSongs.ToList().ForEach(Sub(x) x.Genre = s.Genre)
            End If
        Next
        CurrentSong = SelectedSongs.FirstOrDefault()
        SelectedSongs.Clear()
    End Sub
End Class
